/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#include "nmm/multimedia/INode.idl"
#include "nmm/multimedia/IUsageNotify.idl"

module NMM{
  /**
   * Interface to control TVManager 
   */
  interface ITVManager{

    Result setChannel(in nmm_uint32 channel);
    Result channelUp();
    Result channelDown();

    INode* getTVCard();
    Result startGraph();
    void setUsageNotify(in IUsageNotify* u);
    void releaseGraph();

  };

  /**
   * This interface is used by the TVManager to notify applications about certain Events 
   */
  interface ITVManagerEvents {

    /**
     *Indicates on channel-switch that the next channel is not available on the current TVCard and the source will be switched
     */
    Result switchingSource();

    /**
     *Indicates that the application couldn't request the source exclusive and is only slave
     */
    Result sharedSource();

    /**
     *Indocates, that the next channel is unavailable and therefore left out while channel-hopping
     */
    Result skippingChannel();
  };

}
